Subject: Re: [PATCH] IPv6: optionaly validate RAs on raw sockets

From: Rémi Denis-Courmont <[email-masked]>
Date: Wed, 11 Jul 2007 15:44:43 +0300

On Wednesday 11 July 2007 15:29:16 YOSHIFUJI Hideaki / 吉藤英明 wrote:
> In article <[email-masked]> (at Tue, 10 Jul 2007 
21:11:17 +0300), Remi Denis-Courmont <[email-masked]> says:
> > ICMPv6 Router Advertisements may now contain informations that is
> > mostly of interest to userland. This currently mostly consists of
> > recursive DNS server addresses (though one should expect other
> > stuff to come).
>
> I really do not want to have such non-standard API in kernel.

I can only think of a very limited set of ways to extract options from RAs 
that the kernel currently ignores:

1) parse everything in kernel addrconf.c
2) validate RA in kernel, parse userland options in userland
3) parse everything in userland
4) do not support any option of interest to userland ever
5) userland and kernel do their own cooking separately

netdev folks already rejected (1) earlier. You just rejected (2) this instant. 
(3) implies removing addrconf from the kernel completely, which does not 
sound good, besides being a big waste. (4) means Linux is unusable on IPv6 
networks. And it's already been pointed out (5) was not safe/secure (userland 
may end up accepting something when it should not).

I might be missing something because I am a notoriously arrogant moron but it 
looks like Linux IPv6 is in a dead-end for the time being :-(

What do you propose then?

-- 
Rémi Denis-Courmont